/*
    Copyright (C) 1999-2001 Rui Miguel Silva Seabra <rms@greymalkin.yi.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
gint curr_vl=0,curr_vr=0;
void irmctl_xmms_remote_skip(gint *s, gint *step) {
	xmms_remote_jump_to_time(*s, xmms_remote_get_output_time(*s)+((*step)*1000));
}
void irmctl_xmms_remote_track(gint *s, gint *pos) {
	xmms_remote_set_playlist_pos(*s, (*pos)-1);
}
void irmctl_xmms_remote_volume(gint *s, gint *step) {
	gint lv,rv;
	xmms_remote_get_volume(*s, &lv, &rv);
	xmms_remote_set_volume(*s, lv+(*step), rv+(*step));
}
void irmctl_xmms_remote_mute(gint *s) {
	if(!(curr_vl || curr_vr)) {
		xmms_remote_get_volume(*s, &curr_vl, &curr_vr);
		xmms_remote_set_volume(*s, 0, 0);
	} else {
		xmms_remote_set_volume(*s, curr_vl, curr_vr);
		curr_vl=curr_vr=0;
	}
}

void irmctl_clear_pl_list(gpointer data, gpointer user_data) {
	g_free(data);
}

void irmctl_xmms_remote_playlist(gint *s, gchar *path) {
	gchar file[256];
	GList *files;
	FILE *pl = fopen(path, "r");

	if(!pl) {
		g_warning("Could not open %s: %s\n", path, g_strerror(errno));
	} else {
		files=g_list_alloc();
		xmms_remote_playlist_clear(*s);

		fgets(file, 256, pl);
		files->data=g_strdup(file);
		while(fgets(file, 256, pl))
			files=g_list_append(files, g_strdup(file));
		xmms_remote_playlist_add(*s, files);
		g_list_foreach(files, irmctl_clear_pl_list, NULL);
		g_list_free(files);
		fclose(pl);
	}
}
void irmctl_xmms_remote_playlist_next(gint *s) {
	xmms_remote_playlist_next(*s);
}
void irmctl_xmms_remote_playlist_prev(gint *s) {
	xmms_remote_playlist_prev(*s);
}
void irmctl_xmms_remote_pause(gint *s) {
	xmms_remote_pause(*s);
}
void irmctl_xmms_remote_stop(gint *s) {
	xmms_remote_stop(*s);
}
void irmctl_xmms_remote_play(gint *s) {
	xmms_remote_play(*s);
}

pIRMCTL irmctl_loadBuiltInXMMS(xmlNodePtr node, pIRMCTL conf) {
	xmlNodePtr action = node->childs;
	gchar *switchBut=(gchar*)xmlGetProp(node, (xmlChar*)"SWITCH");
	pACTION a;
	pFUNCTION func;
	pMODE mode;

	mode = (pMODE)g_malloc(sizeof(MODE));
	if(!mode) irmctl_error_memory("Failed to parse XMMS configuration");

	mode->name = g_strdup((gchar*)node->name);
	if(!mode->name)
		irmctl_error_memory("Failed to parse XMMS configuration");

	mode->actions = g_hash_table_new(g_str_hash, g_str_equal);
	if(!mode->actions)
		irmctl_error_memory("Failed to parse XMMS configuration");

	while(action) {
		gchar *button=(gchar*)xmlGetProp(action, (xmlChar*)"NAME");
		if(!g_strcasecmp((gchar*)action->name,"PLAY")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=1;
			func->a1type=1;
			func->args=irmctl_xmms_remote_play;
			func->arg1.intarg=0;

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"STOP")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=1;
			func->a1type=1;
			func->args=irmctl_xmms_remote_stop;
			func->arg1.intarg=0;

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"PAUSE")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=1;
			func->a1type=1;
			func->args=irmctl_xmms_remote_pause;
			func->arg1.intarg=0;

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"SKIP")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=2;
			func->a1type=1;
			func->a2type=1;
			func->args=irmctl_xmms_remote_skip;
			func->arg1.intarg=0;
			func->arg2.intarg=strtol((gchar*)xmlGetProp(action,
						 (xmlChar*)"STEP"), NULL, 10);

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"PREV")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=1;
			func->a1type=1;
			func->args=irmctl_xmms_remote_playlist_prev;
			func->arg1.intarg=0;

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"NEXT")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=1;
			func->a1type=1;
			func->args=irmctl_xmms_remote_playlist_next;
			func->arg1.intarg=0;

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"MUTE")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=1;
			func->a1type=1;
			func->args=irmctl_xmms_remote_mute;
			func->arg1.intarg=0;

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"VOLUME")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=2;
			func->a1type=1;
			func->a2type=1;
			func->args=irmctl_xmms_remote_volume;
			func->arg1.intarg=0;
			func->arg2.intarg=strtol((gchar*)xmlGetProp(action,
						 (xmlChar*)"STEP"), NULL, 10);

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"TRACK")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=2;
			func->a1type=1;
			func->a2type=1;
			func->args=irmctl_xmms_remote_volume;
			func->arg1.intarg=0;
			func->arg2.intarg=strtol((gchar*)xmlGetProp(action,
						 (xmlChar*)"POS"), NULL, 10);

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		} else if(!g_strcasecmp((gchar*)action->name,"PLAYLIST")) {
			a = (pACTION)g_malloc(sizeof(ACTION));
			func = (pFUNCTION)g_malloc(sizeof(FUNCTION));
			if(!( a || func))
				irmctl_error_memory("Failed to parse XMMS "
						    "configuration");

			a->type=1;
			func->type=2;
			func->a1type=1;
			func->a2type=0;
			func->args=irmctl_xmms_remote_playlist;
			func->arg1.intarg=0;
			func->arg2.chararg=
			    g_strdup((gchar*)xmlNodeGetContent(action->childs));

			a->handler.func=func;
			g_hash_table_insert(mode->actions, g_strdup(button), a);
		}
		action=action->next;
	}
	g_hash_table_insert(conf->modes, g_strdup(switchBut), mode);
	return conf;
}
