/*
    Copyright (C) 1999-2001 Rui Miguel Silva Seabra <rms@greymalkin.yi.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "libirmctl.h"

IRMCTL_CODE * irmctl_get_code() {
	IRMCTL_CODE * c;
	c=irmctl_irman_readcode_as_text();
	//c=(IRMCTL_CODE*)g_string_assign((GString*)c,
					//(gchar*)irmctl_readcode);
#ifdef DEBUG
	g_message("Code read (run 1)");
#endif
	return g_strdup(c);
}

gboolean irmctl_irman_init_device(gchar * device) {
	if(ir_init(device)<0) {
#ifdef DEBUG
		g_warning("Device not ready: %s", device);
#endif
		return(FALSE);
	}
#ifdef DEBUG
	g_message("Device opened");
#endif
	return(TRUE);
}

void irmctl_irman_finish_device(gchar * device) {
	ir_finish();
#ifdef DEBUG
	g_message("Device closed");
#endif
}


void irmctl_code_free(gchar * code) {
	g_free(code);
}

IRMCTL_CODE * irmctl_irman_readcode_as_text() {
	register guchar *t; 		/* thanks for this luc */
	
	while (!(t = ir_get_code()));
#ifdef __IRMCTL_CATCH_DUP
	ir_get_code();
#endif
	return (IRMCTL_CODE*)ir_code_to_text(t);
}
