/*
    Copyright (C) 1999-2001 Rui Miguel Silva Seabra <rms@greymalkin.yi.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include <syslog.h>

#include <glib.h>



#ifndef __LIBIRMCTL_H_
 #define __LIBIRMCTL_H_



/* Simple API
 *
 */
//#define IRMCTL_CODE GString
#define IRMCTL_CODE gchar

/* irmctl_get_code() reads a code and returns it (eg: test value).
 * return value SHOULD be allocated with irmctl_alloc()
 */
IRMCTL_CODE * irmctl_get_code();

/* #defined init and finish functions:
 *
   irmctl_init_device(gchar * d)
   irmctl_finish_device(gchar * d)
 *
 */

/* This functions allocate memory for a code and free it, respectively
 *
 */
void irmctl_code_free(IRMCTL_CODE * c);




/* If we are using Evation's IRMAN
 *
 */
#ifdef __IRMCTL_USE_IRMAN

#include <irman.h>

gboolean irmctl_irman_init_device(gchar * device);
void irmctl_irman_finish_device(gchar * device);
IRMCTL_CODE * irmctl_irman_readcode_as_text();

  #define CODE_SIZE 12
  #define irmctl_init_device(d) irmctl_irman_init_device(d)
  #define irmctl_finish_device(d) irmctl_irman_finish_device(d)
  #define irmctl_readcode irmctl_irman_readcode_as_text()
#endif




#endif
